
/*
* Copyright (C) 2004-2014 Texas Instruments Incorporated - http://www.ti.com/
* All rights reserved.	
*
*  Redistribution and use in source and binary forms, with or without
*  modification, are permitted provided that the following conditions
*  are met:
*
*    Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the
*    distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/

#ifndef _CSLR__KEYMGR_001_H_
#define _CSLR__KEYMGR_001_H_

#include <cslr.h>

#include <tistdtypes.h>


/* Minimum unit = 1 byte */

/**************************************************************************\
* Register Overlay Structure
\**************************************************************************/
typedef struct  {
    volatile Uint32 REVID;
    volatile Uint32 STAT;
    volatile Uint32 CHKSUMSTAT;
    volatile Uint8 RSVD0[4];
    volatile Uint32 KEY1WRD0;
    volatile Uint32 KEY1WRD1;
    volatile Uint32 KEY1WRD2;
    volatile Uint32 KEY1WRD3;
    volatile Uint32 KEY2WRD0;
    volatile Uint32 KEY2WRD1;
    volatile Uint32 KEY2WRD2;
    volatile Uint32 KEY2WRD3;
    volatile Uint32 KEY3WRD0;
    volatile Uint32 KEY3WRD1;
    volatile Uint32 KEY3WRD2;
    volatile Uint32 KEY3WRD3;
} CSL_KeymgrRegs;

/**************************************************************************\
* Field Definition Macros
\**************************************************************************/

/* REVID */

#define CSL_KEYMGR_REVID_SCHEME_MASK (0xC0000000u)
#define CSL_KEYMGR_REVID_SCHEME_SHIFT (0x0000001Eu)
#define CSL_KEYMGR_REVID_SCHEME_RESETVAL (0x00000001u)


#define CSL_KEYMGR_REVID_FUNC_MASK (0x0FFF0000u)
#define CSL_KEYMGR_REVID_FUNC_SHIFT (0x00000010u)
#define CSL_KEYMGR_REVID_FUNC_RESETVAL (0x000001E5u)

#define CSL_KEYMGR_REVID_RTL_MASK (0x0000F800u)
#define CSL_KEYMGR_REVID_RTL_SHIFT (0x0000000Bu)
#define CSL_KEYMGR_REVID_RTL_RESETVAL (0x00000000u)

#define CSL_KEYMGR_REVID_MAJOR_MASK (0x00000700u)
#define CSL_KEYMGR_REVID_MAJOR_SHIFT (0x00000008u)
#define CSL_KEYMGR_REVID_MAJOR_RESETVAL (0x00000001u)

#define CSL_KEYMGR_REVID_CUSTOM_MASK (0x000000C0u)
#define CSL_KEYMGR_REVID_CUSTOM_SHIFT (0x00000006u)
#define CSL_KEYMGR_REVID_CUSTOM_RESETVAL (0x00000000u)

#define CSL_KEYMGR_REVID_MINOR_MASK (0x0000003Fu)
#define CSL_KEYMGR_REVID_MINOR_SHIFT (0x00000000u)
#define CSL_KEYMGR_REVID_MINOR_RESETVAL (0x00000000u)

#define CSL_KEYMGR_REVID_RESETVAL (0x41E50100u)

/* STAT */


#define CSL_KEYMGR_STAT_NUMKEYS_MASK (0x00FF0000u)
#define CSL_KEYMGR_STAT_NUMKEYS_SHIFT (0x00000010u)
#define CSL_KEYMGR_STAT_NUMKEYS_RESETVAL (0x00000000u)


#define CSL_KEYMGR_STAT_EFUSEERR_MASK (0x00001F00u)
#define CSL_KEYMGR_STAT_EFUSEERR_SHIFT (0x00000008u)
#define CSL_KEYMGR_STAT_EFUSEERR_RESETVAL (0x00000000u)
/*----EFUSEERR Tokens----*/
#define CSL_KEYMGR_STAT_EFUSEERR_NOERROR (0x00000000u)


#define CSL_KEYMGR_STAT_CHKSUMPASS_MASK (0x00000004u)
#define CSL_KEYMGR_STAT_CHKSUMPASS_SHIFT (0x00000002u)
#define CSL_KEYMGR_STAT_CHKSUMPASS_RESETVAL (0x00000000u)
/*----CHKSUMPASS Tokens----*/
#define CSL_KEYMGR_STAT_CHKSUMPASS_INVALID (0x00000000u)
#define CSL_KEYMGR_STAT_CHKSUMPASS_VALID (0x00000001u)

#define CSL_KEYMGR_STAT_CHKSUMDONE_MASK (0x00000002u)
#define CSL_KEYMGR_STAT_CHKSUMDONE_SHIFT (0x00000001u)
#define CSL_KEYMGR_STAT_CHKSUMDONE_RESETVAL (0x00000000u)
/*----CHKSUMDONE Tokens----*/
#define CSL_KEYMGR_STAT_CHKSUMDONE_INCOMPLETE (0x00000000u)
#define CSL_KEYMGR_STAT_CHKSUMDONE_COMPLETE (0x00000001u)

#define CSL_KEYMGR_STAT_KEYRDY_MASK (0x00000001u)
#define CSL_KEYMGR_STAT_KEYRDY_SHIFT (0x00000000u)
#define CSL_KEYMGR_STAT_KEYRDY_RESETVAL (0x00000000u)
/*----KEYRDY Tokens----*/
#define CSL_KEYMGR_STAT_KEYRDY_NOTRDY (0x00000000u)
#define CSL_KEYMGR_STAT_KEYRDY_RDY (0x00000001u)

#define CSL_KEYMGR_STAT_RESETVAL (0x00000000u)

/* CHKSUMSTAT */



#define CSL_KEYMGR_CHKSUMSTAT_KEY3STAT_MASK (0x00000008u)
#define CSL_KEYMGR_CHKSUMSTAT_KEY3STAT_SHIFT (0x00000003u)
#define CSL_KEYMGR_CHKSUMSTAT_KEY3STAT_RESETVAL (0x00000000u)
/*----KEY3STAT Tokens----*/
#define CSL_KEYMGR_CHKSUMSTAT_KEY3STAT_INVALID (0x00000000u)
#define CSL_KEYMGR_CHKSUMSTAT_KEY3STAT_VALID (0x00000001u)

#define CSL_KEYMGR_CHKSUMSTAT_KEY2STAT_MASK (0x00000004u)
#define CSL_KEYMGR_CHKSUMSTAT_KEY2STAT_SHIFT (0x00000002u)
#define CSL_KEYMGR_CHKSUMSTAT_KEY2STAT_RESETVAL (0x00000000u)
/*----KEY2STAT Tokens----*/
#define CSL_KEYMGR_CHKSUMSTAT_KEY2STAT_INVALID (0x00000000u)
#define CSL_KEYMGR_CHKSUMSTAT_KEY2STAT_VALID (0x00000001u)

#define CSL_KEYMGR_CHKSUMSTAT_KEY1STAT_MASK (0x00000002u)
#define CSL_KEYMGR_CHKSUMSTAT_KEY1STAT_SHIFT (0x00000001u)
#define CSL_KEYMGR_CHKSUMSTAT_KEY1STAT_RESETVAL (0x00000000u)
/*----KEY1STAT Tokens----*/
#define CSL_KEYMGR_CHKSUMSTAT_KEY1STAT_INVALID (0x00000000u)
#define CSL_KEYMGR_CHKSUMSTAT_KEY1STAT_VALID (0x00000001u)


#define CSL_KEYMGR_CHKSUMSTAT_RESETVAL (0x00000000u)

/* KEY1WRD0 */

#define CSL_KEYMGR_KEY1WRD0_KEYINFO_MASK (0xFFFFFFFFu)
#define CSL_KEYMGR_KEY1WRD0_KEYINFO_SHIFT (0x00000000u)
#define CSL_KEYMGR_KEY1WRD0_KEYINFO_RESETVAL (0x00000000u)

#define CSL_KEYMGR_KEY1WRD0_RESETVAL (0x00000000u)

/* KEY1WRD1 */

#define CSL_KEYMGR_KEY1WRD1_KEYINFO_MASK (0xFFFFFFFFu)
#define CSL_KEYMGR_KEY1WRD1_KEYINFO_SHIFT (0x00000000u)
#define CSL_KEYMGR_KEY1WRD1_KEYINFO_RESETVAL (0x00000000u)

#define CSL_KEYMGR_KEY1WRD1_RESETVAL (0x00000000u)

/* KEY1WRD2 */

#define CSL_KEYMGR_KEY1WRD2_KEYINFO_MASK (0xFFFFFFFFu)
#define CSL_KEYMGR_KEY1WRD2_KEYINFO_SHIFT (0x00000000u)
#define CSL_KEYMGR_KEY1WRD2_KEYINFO_RESETVAL (0x00000000u)

#define CSL_KEYMGR_KEY1WRD2_RESETVAL (0x00000000u)

/* KEY1WRD3 */

#define CSL_KEYMGR_KEY1WRD3_KEYINFO_MASK (0xFFFFFFFFu)
#define CSL_KEYMGR_KEY1WRD3_KEYINFO_SHIFT (0x00000000u)
#define CSL_KEYMGR_KEY1WRD3_KEYINFO_RESETVAL (0x00000000u)

#define CSL_KEYMGR_KEY1WRD3_RESETVAL (0x00000000u)

/* KEY2WRD0 */

#define CSL_KEYMGR_KEY2WRD0_KEYINFO_MASK (0xFFFFFFFFu)
#define CSL_KEYMGR_KEY2WRD0_KEYINFO_SHIFT (0x00000000u)
#define CSL_KEYMGR_KEY2WRD0_KEYINFO_RESETVAL (0x00000000u)

#define CSL_KEYMGR_KEY2WRD0_RESETVAL (0x00000000u)

/* KEY2WRD1 */

#define CSL_KEYMGR_KEY2WRD1_KEYINFO_MASK (0xFFFFFFFFu)
#define CSL_KEYMGR_KEY2WRD1_KEYINFO_SHIFT (0x00000000u)
#define CSL_KEYMGR_KEY2WRD1_KEYINFO_RESETVAL (0x00000000u)

#define CSL_KEYMGR_KEY2WRD1_RESETVAL (0x00000000u)

/* KEY2WRD2 */

#define CSL_KEYMGR_KEY2WRD2_KEYINFO_MASK (0xFFFFFFFFu)
#define CSL_KEYMGR_KEY2WRD2_KEYINFO_SHIFT (0x00000000u)
#define CSL_KEYMGR_KEY2WRD2_KEYINFO_RESETVAL (0x00000000u)

#define CSL_KEYMGR_KEY2WRD2_RESETVAL (0x00000000u)

/* KEY2WRD3 */

#define CSL_KEYMGR_KEY2WRD3_KEYINFO_MASK (0xFFFFFFFFu)
#define CSL_KEYMGR_KEY2WRD3_KEYINFO_SHIFT (0x00000000u)
#define CSL_KEYMGR_KEY2WRD3_KEYINFO_RESETVAL (0x00000000u)

#define CSL_KEYMGR_KEY2WRD3_RESETVAL (0x00000000u)

/* KEY3WRD0 */

#define CSL_KEYMGR_KEY3WRD0_KEYINFO_MASK (0xFFFFFFFFu)
#define CSL_KEYMGR_KEY3WRD0_KEYINFO_SHIFT (0x00000000u)
#define CSL_KEYMGR_KEY3WRD0_KEYINFO_RESETVAL (0x00000000u)

#define CSL_KEYMGR_KEY3WRD0_RESETVAL (0x00000000u)

/* KEY3WRD1 */

#define CSL_KEYMGR_KEY3WRD1_KEYINFO_MASK (0xFFFFFFFFu)
#define CSL_KEYMGR_KEY3WRD1_KEYINFO_SHIFT (0x00000000u)
#define CSL_KEYMGR_KEY3WRD1_KEYINFO_RESETVAL (0x00000000u)

#define CSL_KEYMGR_KEY3WRD1_RESETVAL (0x00000000u)

/* KEY3WRD2 */

#define CSL_KEYMGR_KEY3WRD2_KEYINFO_MASK (0xFFFFFFFFu)
#define CSL_KEYMGR_KEY3WRD2_KEYINFO_SHIFT (0x00000000u)
#define CSL_KEYMGR_KEY3WRD2_KEYINFO_RESETVAL (0x00000000u)

#define CSL_KEYMGR_KEY3WRD2_RESETVAL (0x00000000u)

/* KEY3WRD3 */

#define CSL_KEYMGR_KEY3WRD3_KEYINFO_MASK (0xFFFFFFFFu)
#define CSL_KEYMGR_KEY3WRD3_KEYINFO_SHIFT (0x00000000u)
#define CSL_KEYMGR_KEY3WRD3_KEYINFO_RESETVAL (0x00000000u)

#define CSL_KEYMGR_KEY3WRD3_RESETVAL (0x00000000u)

#endif
